package mimuw.mmf.clusterers.hierarchical;

import java.util.LinkedList;
import java.util.List;

/**
 * Leaf represents a cluster that contains only one object, and doesn't consist of
 * other clusters.
 * 
 * @author milosz
 *
 * @param <T>
 */
public class Leaf<T> extends HierarchicalCluster<T> {
	
	private final T instance;
	
	public Leaf(T instance) {	
		super(null, null, 0);
		this.instance = instance;
	}
	
	@Override
	public int size(){
		return 1;
	}
	
	@Override
	public String toString(){
		return instance.toString();
	}
	
	@Override
	public String valsToString(){
		return instance.toString();
	}
	
	@Override
	public List<T> getObjects(){
		List<T> singleton = new LinkedList<T>();
		singleton.add(instance);
		return singleton;
	}
	
	@Override
	public String fullNewickFormat(){
		return toString();
	}
}
