package mimuw.mmf.clusterers.kmedoids;

import java.util.ArrayList;
import java.util.List;

import mimuw.mmf.clusterers.Cluster;

public class KMedoidsCluster<T> implements Cluster<ObjectHolder<T>> {

	private final List<ObjectHolder<T>> holders;
	private ObjectHolder<T> medoidHolder;
	
	
	public KMedoidsCluster(ObjectHolder<T> medoid) {
		super();
		this.holders = new ArrayList<ObjectHolder<T>>();
		this.medoidHolder = medoid;
	}

	
	public ObjectHolder<T> getMedoidHolder() {
		return medoidHolder;
	}

	public List<ObjectHolder<T>> getObjects() {
		return holders;
	}

	public int size() {
		return holders.size();
	}

	public void setMedoidHolder(ObjectHolder<T> medoidHolder) {
		this.medoidHolder = medoidHolder;
	}

	@Override
	public String toString(){
		StringBuffer result = new StringBuffer();
		result.append("Medoid: " + medoidHolder.getObject() + ", other objects: ");
		for (ObjectHolder<T> h: holders){
			if (h.isMedoid) continue;
			result.append(h.getObject().toString());
			result.append(", ");
		}
		return result.toString();
	}
}
