package mimuw.mmf.config;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import mimuw.mmf.MMF.CLUSTERING_TYPE;
import mimuw.mmf.MMF.DISTRIBUTION_DISTANCE_FUNCTION;
import mimuw.mmf.MMF.DISTRIBUTION_TYPE;
import mimuw.mmf.finders.MMFRuntimeException;
import mimuw.mmf.util.Logger.LOG_LEVEL;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;


@SuppressWarnings("unused")
public class ConfigDOMParser {

	ConfigData configData;
	String findersPath;
	Integer motifLength;
	Boolean bothStrands; 
	Integer motifsReported;
	boolean weederOnlyBestHalf;
	String tmpResultsPath;
	String verboseHelpPath;
	DISTRIBUTION_DISTANCE_FUNCTION function;
	DISTRIBUTION_TYPE type;
	Double refinementThreshold;
	CLUSTERING_TYPE clusteringType;
	double hierClusteringThreshold;
	double gcContent;
	String species;
	LOG_LEVEL logLevel;
	boolean jaspar;
	String jasparInfo;
	String jasparAnnotation;
	String jasparData;
	String jasparExpectedClass;
	public /*ConfigData */ void parse(String xmlFile) throws SAXException, IOException, ParserConfigurationException{
		File file = new File(xmlFile);
		if (file.exists()){
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			javax.xml.parsers.DocumentBuilder builder = factory.newDocumentBuilder();
			Document doc = builder.parse(xmlFile);
			
			Node findersNode = doc.getElementsByTagName("finders").item(0);
			System.out.println("Path: " + findersPath);
			
			Node appNode = doc.getElementsByTagName("application").item(0);
			Node jasparNode = doc.getElementsByTagName("jaspar").item(0);
			
		} else {
			throw new MMFRuntimeException("Config file " + xmlFile + " doesn't exist");
		}
	}
	
	
	
	private FindersData toFindersData(Node findersNode){
		
		NamedNodeMap findersAttrs = findersNode.getAttributes();
		
		String findersPath = findersAttrs.getNamedItem("path").getNodeValue();
		Integer motifLength;
		Integer motifsReported;	
		
		try {
			motifLength = new Integer(getAttribute(findersAttrs, "motif_length"));
		} catch (NumberFormatException e){
			throw new MMFRuntimeException("Wrong value of attribute 'motif_length' in 'finders' element(not int)");
		}
		Boolean bothStrands = new Boolean(getAttribute(findersAttrs, "both_strands"));
		try {
			motifsReported= new Integer(getAttribute(findersAttrs, "motifs_reported"));
		} catch (NumberFormatException e){
			throw new MMFRuntimeException("Wrong value of attribute 'motifs_reported' in 'finders' element(not int)");
		}

		Node weederNode = findersNode.getFirstChild();
		Boolean weederOnlyBestHalf = new Boolean (getAttribute(weederNode.getAttributes(),"only_best_half"));
		FindersData findersData = null; //new FindersData(findersPath, motifLength, bothStrands, motifsReported, weederOnlyBestHalf);
		
		return findersData;
	}
	
	private String getAttribute(NamedNodeMap attributes, String name){
		return attributes.getNamedItem(name).getNodeValue();
	}
	
	public static void main(String[] args){
		try {
			new ConfigDOMParser().parse("config.xml");
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
