package mimuw.mmf.util;

import org.biojava.bio.dist.Distribution;

import mimuw.mmf.config.ConfigData;

public class Constants {

	public static final String CONFIG_PATH = "config.xml";
	
	public static String FINDERS_PATH;
	public static String TMP_RESULTS_DIR;
	public static String VERBOSE_HELP_FILE;
	public static boolean WEEDER_CONSIDER_ONLY_BEST_HALF = true;
	private static Distribution bgDist = BioTools.getDNADistribution(0.499);
	
	public static void initialize(ConfigData data){
		FINDERS_PATH =  data.getFindersData().getFindersPath();
		TMP_RESULTS_DIR = data.getAppData().getTmpResultsPath();
		VERBOSE_HELP_FILE = data.getAppData().getVerboseHelpPath();
		WEEDER_CONSIDER_ONLY_BEST_HALF = data.getFindersData().isWeederOnlyBestHalf();
		bgDist = BioTools.getDNADistribution(data.getAppData().getGcContent());
	}

	public static Distribution getBgDist() {
		return bgDist;
	}
	
	
}
